/* moveEvaluation.h
 */
#ifndef OSL_CATEGORY_MOVEEVALUATION_H
#define OSL_CATEGORY_MOVEEVALUATION_H

#include "osl/eval/pieceEval.h"
#include "osl/state/numEffectState.h"
#include "osl/container/position8.h"

namespace osl
{
  namespace category
  {
    class CategoryEnv;
    /**
     * ¸ΨλФɬפʻؼζɾ
     */
    struct MoveEvaluation
    {
      static int evalLight(const NumEffectState& state, Move move)
      {
	return PieceEval::computeDiffAfterMoveForRP(state, move);
      }
      static int evalDetailed(const CategoryEnv& env, Move move,
			      const Position8& sendoffs);
    };
  }
} // namespace osl

#endif /* OSL_CATEGORY_MOVEEVALUATION_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
