/* alphaBetaPlayer.h
 */
#ifndef GAMEPLAYING_ALPHABETAPLAYER_H
#define GAMEPLAYING_ALPHABETAPLAYER_H

#include "osl/game_playing/searchPlayer.h"
#include <boost/scoped_ptr.hpp>

namespace osl
{
  namespace game_playing
  {
    class AlphaBeta2Player : public SearchPlayer
    {
    public:
      AlphaBeta2Player();
      ~AlphaBeta2Player();
      ComputerPlayer* clone() const;

      const MoveWithComment searchWithSecondsForThisMove(const GameState&, int seconds);
      bool isReasonableMove(const GameState&, Move move, int pawn_sacrifice);
    };
  } // namespace game_playing
} // namespace osl

#endif /* GAMEPLAYING_ALPHABETAPLAYER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
