/* historyToTable.h
 */
#ifndef GAME_PLAYING_HISTORYTOTABLE_H
#define GAME_PLAYING_HISTORYTOTABLE_H
namespace osl
{
  class Move;
  namespace hash
  {
    class HashKey;
  }
  namespace search
  {
    class SimpleHashTable;
  }
  namespace game_playing
  {
    class GameState;
    struct HistoryToTable
    {
      /** table ˽񤭹࿼ */
      static const int LIMIT;
      /**
       * key ζ̤λ̤Ͽ
       */
      static void adjustDominance(const hash::HashKey& key, 
				  search::SimpleHashTable& table,
				  int black_win, int white_win,
				  const Move& good_move);
      /**
       * table 󡤿ʿкϿ
       */
      static void adjustTable(const GameState&, 
			      search::SimpleHashTable& table,
			      int black_win, int draw, int white_win);
    };
  } // namespace game_playing
} // namespace osl

#endif /* GAME_PLAYING_HISTORYTOTABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
