#ifndef _MOVE_GENERATOR_PROMOTE_H
#define _MOVE_GENERATOR_PROMOTE_H
#include "osl/player.h"
#include "osl/move_action/concept.h"
namespace osl
{
  namespace move_generator
  {
    /**
     * .
     * unique
     * ΥåϤʤΤǡǽ?
     * @param  noCapture - trueλ϶ʤ(̤ǽ⤤Τ)
     */
    template<Player P,class State,class Action,bool noCapture=true>
    class Promote
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      BOOST_STATIC_ASSERT(sizeof(typename State::simple_board_t));
    public:
      template<Ptype T>
      static void generateMovesPtype(const State& state, Action& action);
      static void generateMoves(const State& state, Action& action);
    };


    /**
     * Player ü첽 Action instantiate ̵̤ʤΤա
     */
    template<bool NoCapture>
    struct GeneratePromote
    {
      template<class State,class Action>
      static void generate(Player p, const State& state, Action& action)
      {
	if (p == BLACK)
	  Promote<BLACK,State,Action,NoCapture>::generateMoves(state, action);
	else
	  Promote<WHITE,State,Action,NoCapture>::generateMoves(state, action);
      }
    };
  }
}
#endif /* _MOVE_GENERATOR_PROMOTE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
