/* usi.h
 */
#ifndef _USI_H
#define _USI_H

#include "osl/move.h"
#include <string>

namespace osl
{
  namespace state
  {
    class SimpleState;
  }
  namespace record
  {
    namespace usi
    {
      const Move strToMove(const std::string&, const state::SimpleState&);
      PtypeO charToPtypeO(char);

      const std::string show(Move);
      /** ̤ */
      void parseBoard(const std::string& board, state::SimpleState&);
      /**  [sfen <sfenstring> | startpos ] moves <move1> ... <movei> */
      void parse(const std::string& line, state::SimpleState&);
    }
  } // record
} // osl

#endif /* _USI_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
