/* searchMoveSorter.h
 */
#ifndef SEARCH_MOVESORTER_H
#define SEARCH_MOVESORTER_H
#include "osl/eval/evalCompareLarger.h"
#include "osl/search/searchMove.h"
#include "osl/stl/multimap.h"

namespace osl
{
  namespace search
  {
    /**
     * MTDF::computeBestMoveLower ɾ()⤤˼¤٤.
     * Ͼ夫Ĥsort ƤɤΤ over specification ⤷ʤ
     */
    template<Player P>
    struct SearchMoveSorter 
      : private multimap<int,const SearchMove*,eval::EvalCompareLarger<P> >
    {
      typedef multimap<int,const SearchMove*,eval::EvalCompareLarger<P> > base_t;
      typedef std::pair<int,const SearchMove*> pair_t;
      using base_t::iterator;
      using base_t::const_iterator;
      using base_t::const_reverse_iterator;
      using base_t::size;
      using base_t::empty;
      using base_t::begin;
      using base_t::rbegin;
      using base_t::end;
      using base_t::rend;

      // ŤФϤ餫ᥳѥ뤹
      SearchMoveSorter();
      ~SearchMoveSorter();
    
      void insert(const pair_t&);
      void insert(typename base_t::iterator hint, const pair_t&);
      void insert(typename base_t::iterator first, 
		  typename base_t::iterator last);
      void erase(typename base_t::iterator first, typename base_t::iterator last);
      void clear();
      void swap(SearchMoveSorter& o);
      /**
       * @param show_elements ɽǤο 0 ʤ
       */
      void dump(size_t show_elements=0) const;
      void summary(size_t show_elements=0) const;
      bool isValidAll() const;
    };
  } // namespace search
} // namespace os


#endif /* SEARCH_MOVESORTER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
