/* position.cc
 */
#include "osl/rating/feature/position.h"
#include <sstream>

const std::string osl::rating::RelativeKingX::name(int x, bool /*attack*/) 
{
  std::ostringstream os;
  os << "X" << x;
  return os.str();
}

const std::string osl::rating::RelativeKingY::name(int y, bool /*attack*/) 
{
  std::ostringstream os;
  os << "Y" << y;
  return os.str();
}

const std::string osl::rating::PositionX::name(int x) 
{
  std::ostringstream os;
  os << "PX" << x << "-";
  return os.str();
}
const std::string osl::rating::PositionY::name(int y) 
{
  std::ostringstream os;
  os << "PY" << y << "-";
  return os.str();
}

/* ------------------------------------------------------------------------- */
