#include "osl/oslConfig.h"
#include <cppunit/ui/text/TestRunner.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <iostream>
#include <unistd.h>

bool isShortTest=false;
int main(int argc, char **argv)
{
  // extern char *optarg;
  extern int optind;
  bool error_flag = false;
  char c;
  while ((c = getopt(argc, argv, "s")) != EOF)
  {
    switch (c)
    {
    case 's':	isShortTest = true;
      break;
    default:	error_flag = true;
    }
  }
  argc -= optind;
  argv += optind;
  if (error_flag)
  {
    std::cerr << "unknown option\n";
    return 1;
  } 

  osl::OslConfig::setVerbose(true);
  osl::OslConfig::showOslHome();
  
  CppUnit::TextUi::TestRunner runner;

  CppUnit::TestFactoryRegistry &registry 
    = CppUnit::TestFactoryRegistry::getRegistry();
  runner.addTest(registry.makeTest());

  runner.run();
  return 0;
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
