/* categoryEnv.h
 */
#ifndef _CATEGORYENV_H
#define _CATEGORYENV_H

#include "osl/state/numEffectState.h"
#include "osl/progress/progress32.h"
namespace osl
{
  namespace container
  {
    class MoveStack;
  }
  namespace search
  {
    class SimpleHashRecord;
    class HistoryTable;
  }
  namespace category
  {
    using container::MoveStack;
    /**
     * ƥϤĶޤȤ᤿
     */
    struct CategoryEnv
    {
      typedef NumEffectState effect_state_t;
      /**  */
      const effect_state_t *state;
      /** Ψξ (ʾؤˤΤϺʤ) */
      int limit;
      /** ʹ */
      Progress32 progress32;
      /** ޤǤλؼꡥtop()  last move */
      const MoveStack *history;
      // KillerMoveTable *killers ...
      const search::SimpleHashRecord *record;
      // õο
      int depth;
      const search::HistoryTable *history_table;

      CategoryEnv(const effect_state_t *s, int l, const MoveStack *h,
		  Progress32 p=Progress32(0),
		  const search::SimpleHashRecord *r=0,
		  int depth=0,
		  const search::HistoryTable *ht=0)
	: state(s), limit(l), progress32(p), 
	  history(h), record(r), depth(depth),
	  history_table(ht)
      {
      }
    };
  } // namespace category
} // namespace osl


#endif /* _CATEGORYENV_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
