/* selectCheapest.h
 */
#ifndef _SELECTCHEAPEST_H
#define _SELECTCHEAPEST_H

#include "osl/eval/pieceEval.h"
namespace osl
{
  namespace effect_action
  {
    /**
     * ְ¤õ
     */
    struct SelectCheapest
    {
      Piece result;
      int value;
      SelectCheapest()
	: result(Piece::EMPTY()), value(eval::PtypeEvalTraits<KING>::val+1)
      {
      }
      template <Player P>
      void doAction(Piece cur, Position)
      {
	const int curValue = eval::Ptype_Eval_Table.value(cur.ptype());
	if (curValue < value)
	{
	  result = cur;
	  value = curValue;
	}
      }
      bool done() const{ return false; }
    };

  } // namespace effect_action
} // namespace osl

#endif /* _SELECTCHEAPEST_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
