/* mtdfPlayer.h
 */
#ifndef GAMEPLAYING_MTDFPLAYER_H
#define GAMEPLAYING_MTDFPLAYER_H

#include "osl/game_playing/searchPlayer.h"

namespace osl
{
  namespace game_playing
  {
    /**
     * PieceEval Ȥץ쥤()
     */
    class PlainMtdfPlayer : public SearchPlayer
    {
    public:
      PlainMtdfPlayer();
      ~PlainMtdfPlayer();
      ComputerPlayer* clone() const;

      const MoveWithComment searchWithSecondsForThisMove(const GameState&, int seconds);
      bool isReasonableMove(const GameState&, Move move, int pawn_sacrifice);
    };

    /**
     * ProgressEval Ȥ
     */
    class ProgressMtdfPlayer : public SearchPlayer
    {
    public:
      ProgressMtdfPlayer();
      ~ProgressMtdfPlayer();
      ComputerPlayer* clone() const;

      const MoveWithComment searchWithSecondsForThisMove(const GameState&, int seconds);
      bool isReasonableMove(const GameState&, Move move, int pawn_sacrifice);
    };
  } // namespace game_playing
} // namespace osl

#endif /* GAMEPLAYING_MTDFPLAYER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
