/* noAddEffectFilter.h
 */
#ifndef _NOADDEFFECTFILTER_H
#define _NOADDEFFECTFILTER_H

#include "osl/state/simpleState.h"
#include "osl/move_action/concept.h"
namespace osl
{
  namespace move_action
  {
    /**
     * posĤե륿
     */
    template<class OrigAction>
    class NoAddEffectFilter
    {
      BOOST_CLASS_REQUIRE(OrigAction,osl::move_action,Concept);
      const SimpleState& state;
      OrigAction & action;
      Position target;
    public:
      NoAddEffectFilter(const SimpleState& s, OrigAction & action,Position target) : state(s), action(action),target(target) {}
      void simpleMove(Position from,Position to,Ptype ptype, bool isPromote,Player p){
	if(!state.hasEffectFromTo(newPtypeO(p,ptype),to,target))
	  action.simpleMove(from,to,ptype,isPromote,p);
      }
      void unknownMove(Position from,Position to,Piece p1,Ptype ptype,bool isPromote,Player p){
	if(!state.hasEffectFromTo(newPtypeO(p,ptype),to,target))
	  action.unknownMove(from,to,p1,ptype,isPromote,p);
      }
      void dropMove(Position to,Ptype ptype,Player p){
	if(!state.hasEffectFromTo(newPtypeO(p,ptype),to,target))
	  action.dropMove(to,ptype,p);
      }
    };
  } // namespace move_action
} // namespace osl


#endif /* _NOADDEFFECTFILTER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
