/* oslConfig.h
 */
#ifndef OSL_OSLCONFIG_H
#define OSL_OSLCONFIG_H

#include <string>

namespace osl
{
  /** osl μ¹ԴĶ˴ؤ */
  struct OslConfig
  {
    static const int MaxThreads=16;
    /** compile˻ꤵ줿ǥ쥯ȥ֤. ¹ԻλϴĶѿ */
    static const std::string& home();
    static const char * home_c_str();

    /** ƥȥΥǡ */
    static const std::string test();
    static const char *testFile(const std::string& filename);
    static const char *testCsaFile(const std::string& filename);

    /** ɸץե֤
     * @param filename specify to use non-standard file
     * (absolute path, or home()/data/filename otherwise)
     */
    static const char *openingBook(const std::string& filenamme="");

    static void setVerbose(bool verbose);
    static bool verbose();

    static void showOslHome();
    static void setNumCPUs(int ncpu);
    static int numCPUs();
  private:
    static const std::string makeHome();
    static const std::string makeTest();
    static bool isGoodDir(const std::string&);
    static void trySetDir(std::string&, const std::string&);
    static void showOslHome(const std::string&);
  };
}

#endif /* OSL_OSLCONFIG_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
