/* feature.cc
 */
#include "osl/rating/feature.h"
#include "osl/apply_move/applyMove.h"
#include <sstream>

osl::rating::Feature::~Feature()
{
}

const osl::CArray<const char*,4> osl::rating::Check::check_property = {{ "Direct", "DirectOpen", "OpenCheck", "Both" }};
osl::rating::Check::Check(int p) : Feature(check_property[p]), property(p) 
{
}

const std::string osl::rating::Open::name(int property)
{
  std::ostringstream os;
  os << "Open" << property / 4 << property % 4;
  return os.str();
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
